# daim - OSCAR Protocol Library for Java
# Copyright (C) 2004  David Walluck
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# $Id: fortuneprofile.py,v 1.4 2004/02/12 07:06:23 walluck Exp $

import os
from org.walluck.oscar import SNACFamily
from org.walluck.oscar.script import Script
from java.lang import Exception

class FortuneProfile(Script):
    def __init__(self):
        self.name, self.version, self.description, self.author, self.url, \
                   self.filename = ("Fortune Profile", "1.0", "Sets your AIM \
                   profile to a fortune (with a header and footer of your \
                   choice)", "David Walluck <walluck@dev.java.net>", \
                                    "http://www.jython.org/", \
                                    "fortuneprofile.py")
        bos.registerListener(SNACFamily.AIM_CB_FAM_MSG,
                             SNACFamily.AIM_CB_MSG_INCOMING, self);

        daim.addScript(self)

    def incomingIMCH1(self, sess, frame, channel, userinfo, args):
        print "<" + userinfo.SN +"> " + args.msg

def update_away():
    pre_message, post_message, command, fortune = (None, None, \
"fortune -sn 1013", None)

    while not fortune or len(fortune) > 1024:
        fortune = os.popen(command).read()
        fortune = fortune.replace("&", "&amp;")
        fortune = fortune.replace("<", "&lt;")
        fortune = fortune.replace(">", "&gt;")
        fortune = fortune.replace('"', "&quot;")

        if pre_message:
            fortune = pre_message + "---<BR>" + fortune

        if post_message:
            fortune = post_message + "---<BR>" + fortune

        fortune = "<PRE>\n" + fortune + "\n</PRE>"

    try:
        oscar.setInfo(session, "us-ascii", fortune)
    except Exception, e:
        print "fortuneprofile: failed to set profile: "
        e.printStackTrace()

fp = FortuneProfile()
daim.addTimeoutHandler(fp, 10000, 1, "update_away()")
